// This module is to implement led selection logic
// 
  
 


module led_selection 
(
  input		   clk					            // clock                                                                                               
, input	       CPLD_QSFP_LED_POSITION           // LED selection button input
                                         
, output       top_led_active_n   
, output       bot_led_active_n                  
 
) ;
 

wire  push_button_in_neg_pul  ; 

 
// push button pulse
wire  push_button_in = CPLD_QSFP_LED_POSITION;

neg_edge	pb_in_neg_edge        // push button reset, treated as cold reset
(
.clk	 		(clk),
.rst_n	 		(1'b1),
.sig_in     	(push_button_in),
.neg_edge_en	(push_button_in_neg_pul) 
) ;

 
reg [2:0] led_state_cnt = 3'b0; // initialized to 00 for simulation
 
always @ (posedge clk )
    begin
       if (  push_button_in_neg_pul == 1'b1 )
             led_state_cnt <= led_state_cnt + 3'd1;
       else
             led_state_cnt <= led_state_cnt ;
            
    end 
 
 
wire  led_select =  led_state_cnt[0];

assign    top_led_active_n  = !led_select ; 
assign    bot_led_active_n  =  led_select ; 

endmodule
