//-----------------------------------------------------------------------------
// Title       : Rising edge detector
// Design      : Wedge100 CPLD Design
// File        : pos_edge.v
//-----------------------------------------------------------------------------
// Version     : Ver 2.0
// Changes     : 1. First version
//-----------------------------------------------------------------------------
// Description:- detect rising edge of signals
//-----------------------------------------------------------------------------

module pos_edge
(
  input         clk
 ,input         rst_n
 ,input         sig_in
 ,output        pos_edge_en

) ;

reg [1:0] sig_buf;

always @ (posedge clk or negedge rst_n)
if (!rst_n) sig_buf  <= 2'b00 ;
else        sig_buf  <= {sig_buf[0],sig_in} ;

assign pos_edge_en = (sig_buf == 2'b01) ? 1'b1 :1'b0 ;

endmodule